



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>iOS:核心动画之动画组CAAnimationGroup</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">iOS:核心动画之动画组CAAnimationGroup</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 16:15:55 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>CAAnimationGroup&mdash;&mdash;动画组</div>
<div>动画组，是CAAnimation的子类，可以保存一组动画对象，将CAAnimationGroup对象加入层后，组中所有动画对象可以同时并发运行</div>
<div>属性说明：</div>
<div>&ndash;animations：用来保存一组动画对象的NSArray</div>
<div>默认情况下，一组动画对象是同时运行的，也可以通过设置动画对象的beginTime属性来更改动画的开始时间</div>
<div>&nbsp;</div>
<div>具体的实例如下：</div>
<div>实现功能：在创建的动画组中存入两个基本动画,一个是沿着Z轴旋转360度的动画,另一个是放大2倍的动画,这两个动画并发执行，动画结束后,均不在恢复原状。</div>
<div>代码如下：</div>
<div>//声明属性</p>
<div>
<pre class="prettyprint linenums">#import "ViewController.h"

@interface ViewController ()<br />
@property (strong,nonatomic)CALayer *subLayer; //声明核心动画子层<br />
@end</pre>
</div>
</div>
<div>//创建动画子层,同时创建触摸手势,添加的手势事件处理的是动画组</p>
<div>
<pre class="prettyprint linenums">@implementation ViewController

- (void)viewDidLoad {<br />
    [super viewDidLoad];

    //创建子层<br />
    self.subLayer = [CALayer layer];<br />
    self.subLayer.bounds = CGRectMake(, , , );<br />
    self.subLayer.position = CGPointMake(, );<br />
    self.subLayer.backgroundColor = [[UIColor redColor]CGColor];<br />
    [self.view.layer addSublayer:self.subLayer];

    //添加触摸手势<br />
    UITapGestureRecognizer  *tap = [[UITapGestureRecognizer alloc]initWithTarget:self action:@selector(tap:)];<br />
    tap.numberOfTapsRequired = ;<br />
    tap.numberOfTouchesRequired = ;<br />
    [self.view addGestureRecognizer:tap];<br />
}</pre>
</div>
</div>
<div>//定义方法，返回一个用于旋转的基本动画</p>
<div>
<pre class="prettyprint linenums">#pragma mark 返回一个实现旋转的基本动画<br />
-(CABasicAnimation*)rotationAnimationFromValue:(CGFloat)fromValue toValue:(CGFloat)tovalue<br />
{<br />
    //创建基本动画(用于旋转)<br />
    CABasicAnimation *baseAnimation = [[CABasicAnimation alloc]init];

    //设置形变属性值为旋转属性值<br />
    baseAnimation.keyPath = @"transform.rotation.z";

    //设置旋转初值<br />
    baseAnimation.fromValue = @(fromValue);

    //设置旋转终值<br />
    baseAnimation.toValue = @(tovalue);

    //设置旋转动画持续时间<br />
    baseAnimation.duration = 1.0f;

    //设置动画旋转结束后不恢复原状<br />
    baseAnimation.removedOnCompletion = NO;<br />
    baseAnimation.fillMode = kCAFillModeForwards;

    return baseAnimation;<br />
}</pre>
</div>
</div>
<div>//定义方法，返回一个用于放缩的基本动画</p>
<div>
<pre class="prettyprint linenums">#pragma mark 返回一个实现放缩的基本动画<br />
-(CABasicAnimation*)scaleAnimationFromValue:(CGFloat)fromValue toValue:(CGFloat)tovalue<br />
{<br />
    //创建基本动画(用于放缩)<br />
    CABasicAnimation *animScale = [[CABasicAnimation alloc]init];

    //设置形变属性为放缩属性值<br />
    animScale.keyPath = @"transform.scale";

    //设置放缩初值<br />
    animScale.fromValue = @(fromValue);

    //设置放缩终值<br />
    animScale.toValue = @(tovalue);

    //设置放缩动画持续时间<br />
    animScale.duration = 1.0f;

    //设置动画放缩结束后不恢复原状<br />
    animScale.removedOnCompletion = NO;<br />
    animScale.fillMode = kCAFillModeForwards;

    return animScale;<br />
}</pre>
</div>
</div>
<div>//处理触摸手势的事件,创建动画组,并将上面返回的两个动画对象添加进去,然后并发的执行动画组</p>
<div>
<pre class="prettyprint linenums">#pragma mark -tap触摸事件<br />
-(void)tap:(UITapGestureRecognizer *)sender<br />
{

    //方式一：依次调用各个的动画,效果也是可以的<br />
    //旋转360度<br />
    //[self.subLayer addAnimation:[self rotationAnimationFromValue:-M_PI toValue:M_PI] forKey:@"baseAnimation"];<br /> <br />
    //放大2倍<br />
    //[self.subLayer addAnimation:[self scaleAnimationFromValue:1.0 toValue:2.0] forKey:@"animScale"];

    //方式二：并发执行动画组中的所有动画<br />
    //创建动画组<br />
    CAAnimationGroup *Group = [[CAAnimationGroup alloc]init];

    //将各种动画对象加入数组中<br />
    NSArray *animations = @[[self rotationAnimationFromValue:-M_PI toValue:M_PI],[self scaleAnimationFromValue:1.0 toValue:2.0]];

    //动画数组中的动画的属性受动画组的统一控制<br />
    Group.animations = animations;

    //设置动画组中所有动画的持续时间<br />
    Group.duration = 1.0;

    //设置动画组中所有动画运行结束后不恢复原状<br />
    Group.removedOnCompletion = NO;<br />
    Group.fillMode = kCAFillModeForwards;

    //往子层中添加动画组<br />
    [self.subLayer addAnimation:Group forKey:@"Group"];<br />
}</pre>
</div>
</div>
<div>演示结果如下:</div>
<div>开始时：</div>
<div><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/791499/201510/791499-20151016222927132-615524343.png" /> &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; </div>
<div>某一时刻：(由于动画过程中截取的图,截图比较大一些) &nbsp;</div>
<div><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/791499/201510/791499-20151016222939226-674058443.png" /> &nbsp; &nbsp;</div>
<div> &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; </div>
<div>结束时：</div>
<div><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/791499/201510/791499-20151016222948694-2091791084.png" /></div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9pdrxk9.html">Web前端性能测试-性能测试知多少---深入分析前端站点的性能</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq157ez9.html">《Invert》开发日志05：终止</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rkx7mq.html">FingerprintJS - 在浏览器端实现指纹识别</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9py4k49.html">Qt 使用sqlserver</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93m3kw8.html">MUI - 图片预览（perviewimage）的优化</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1gxrzq.html">利用zxing制作彩色，高容错，支持中文等UTF编码的QR二维码图片</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k10vkj9.html">Elasticsearch--Date math在索引中的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmk7je9.html">spring websocket Converters must not be empty</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y5xg5q.html">spring与mybatis，strut2整合连接sqlserver不的不说的那点事儿</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljx2j69.html">LODOP打印控件示例</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1owloq.html">Python Cookbook&lpar;第3版&rpar;中文版：15&period;19 从C语言中读取类文件对象</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgln148.html">&lpar;转载&rpar;总结一下SQL语句中引号&lpar;&amp;&num;39&semi;&rpar;、quotedstr&lpar;&rpar;、&lpar;&amp;&num;39&semi;&amp;&num;39&semi;&rpar;、format&lpar;&rpar;在SQL语句中的用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gj0w6q.html">Vue 核心之数据劫持</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gw760q.html">beego orm 忽略字段</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjezy39.html">使用ajax请求接口，跨域后cookie无法设置，全局配置ajax；及使用axios跨域后cookie无法设置，全局配置axios</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r52xe4q.html">Linux stress CPU的测试方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7eoj0e9.html">ASP&period;NET MVC同时支持web与webapi模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pmwzj49.html">Yii2用Gii自动生成Module&plus;Model&plus;CRUD</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwo0ool9.html">反射机制2，Class类的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwowrgy9.html">C&num;去除数组空格</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/96o3xy39.html">Ant学习---第三节：使用Ant实现一个最小的项目编译</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ok47el9.html">IE点击tif，tiff文件，提示打开而不是查找</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xp5mn9.html">Node&period;js 学习（五）Node&period;js 事件循环</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnjgooq.html">elasticsearch查询之term&comma;range&comma;prefix</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mepl1q.html">android开发实现静默安装（fota升级）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j0myxgq.html">【Binary Tree Preorder Traversal】cpp</a>
			</li>
						<li><a href="https://www.batexi.com/a/8okdk1p9.html">05&period;Hibernate多对多关联</a>
			</li>
						<li><a href="https://www.batexi.com/a/qde5exz9.html">设计模式之桥接模式&lpar;Bridge&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qde5pe79.html">Word中字体背景有白块咋办</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4y4j7nq.html">CocoaPods 使用手册</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
